#ifndef _NVRAM_H
#define _NVRAM_H



/* header files we depend upon
 */
#include "../types/types.h"
#include "../apptel/amcc.h"



/* errors
 */
#define ERROR_NVRAM_NOT_INITIALIZED     1
#define ERROR_NVRAM_INVALID_ADDRESS     2
#define ERROR_NVRAM_CYCLE_TIMEOUT       3
#define ERROR_NVRAM_MISSING_ARGS        4       // used by callers but not me
#define ERROR_NVRAM_CANNOT_ALLOC        5       // used by callers but not me



/* function prototypes
 */
#ifdef __cplusplus
extern "C" {
#endif

void nvram_init_stats( void );
void nvram_print_stats( void );
int nvram_read_or_write( Amcc_registers *amcc, Bit16 address, int want_write, Bit8 *data0 );

#ifdef __cplusplus
}
#endif



#endif  /* not included yet */
