#include <stdio.h>                  // printf()
#include <string.h>                 // strlen()
#include "..\types\types.h"
#include "far.h"



#define EXPECTED_1      123000666
#define EXPECTED_2      124000777



void main( void )
{
    Bit48 pointer, pointer2;
    Bit32 dummy;
    Bit32 value;
    char base_string[] = "1234567891A";
    char less_string[] = "1234567890A";
    char more_string[] = "1234567892A";
    int result;

    dummy = EXPECTED_1;

    pointer.selector = _DS;
    pointer.offset = (Bit32) &dummy;
    value = far_read32( pointer );
    printf( "reading far 16:32 address 0x%4.4X:%8.8lX expected %d saw %d\n",
        pointer.selector, pointer.offset, EXPECTED_1, value );

    far_write32( pointer, EXPECTED_2 );
    printf( "after writing, expected %d saw %d\n", EXPECTED_2, dummy );

    pointer.offset = (Bit32) &base_string;
    pointer2.offset = (Bit32) &less_string;
    pointer2.selector = _DS;
    result = far_memcmp( pointer, pointer2, strlen(base_string) );
    printf( "comparing src='%s' dst='%s' resulted in %d\n", base_string, less_string, result );

    pointer2.offset = (Bit32) &more_string;
    result = far_memcmp( pointer, pointer2, strlen(base_string) );
    printf( "comparing src='%s' dst='%s' resulted in %d\n", base_string, more_string, result );
}

