#include "../integrat/buffer.h"



int main( int argc, char *argv[] )
{
    BufferBlock *block;
    int result;
    const char *program = argv[ 0 ];
    const char *filename = argv[ 1 ];

    if( argc != 2 )
    {
        fprintf( stderr, "measures disk throughput by dumping all blocks\nusage: %s filename\n", program );
        return 1;
    }

    flat_init();

    CardClock::sync_time.set();

    all_buffers = new BufferQueue;
    if( all_buffers == NULL )
    {
        fprintf( stderr, "cannot allocate BufferQueue!\naborting\n" );
        return 1;
    }

    // move all the blocks from the free list to the filled list
    //
    while( 1 )
    {
        result = all_buffers->allocate( &block );
        if( result )
            break;

        result = all_buffers->fill( block );
        if( result )
            break;
    }
    if( result != ERROR_QUEUE_NOT_FREE )
        fprintf( stderr, "unexpected error %d from BufferQueue::allocate() or BufferQueue::fill()\n", result );
    else
    {
        // dump the filled blocks to disk
        //
        result = all_buffers->dump( filename );
        if( result )
            fprintf( stderr, "error %d from BufferQueue::dump()\n", result );
    }

    delete all_buffers;
    flat_exit();

    return result;
}
