#ifndef _FS2FLOWS_H
#define _FS2FLOWS_H



// header files we depend upon
//
#include "../integrat/aal5.h"
#include "../integrat/buffer.h"             // class BufferBlock



// error codes
//
#define ERROR_FLOWS_BASE                    2000
#define ERROR_FLOWS_NO_ENVAR                (ERROR_FLOWS_BASE + 1)
#define ERROR_FLOWS_CANNOT_CVT_ENVAR        (ERROR_FLOWS_BASE + 2)
#define ERROR_FLOWS_BAD_ENVAR_VALUE         (ERROR_FLOWS_BASE + 3)
#define ERROR_FLOWS_CANNOT_SUBALLOC_FLOW    (ERROR_FLOWS_BASE + 4)
#define ERROR_FLOWS_TOO_FEW_ARGS            (ERROR_FLOWS_BASE + 5)
#define ERROR_FLOWS_UNKNOWN_ARG             (ERROR_FLOWS_BASE + 6)
#define ERROR_FLOWS_CANNOT_ALLOC_TCP_BUF    (ERROR_FLOWS_BASE + 7)
#define ERROR_FLOWS_UNKNOWN_OBJECT_TYPE     (ERROR_FLOWS_BASE + 8)
#define ERROR_FLOWS_CANNOT_ALLOC_FLOWS      (ERROR_FLOWS_BASE + 9)
#define ERROR_FLOWS_CANNOT_ALLOC_FLOW_BUCKETS   (ERROR_FLOWS_BASE + 10)
#define ERROR_FLOWS_CANNOT_ALLOC_CHAINLENS  (ERROR_FLOWS_BASE + 11)
#define ERROR_FLOWS_CORRUPTED_BUFFERBLOCK   (ERROR_FLOWS_BASE + 12)



// manifest constants
//
#define FLOWTRACE_CLIENT_ENVAR    "FLOWTRACE_CLIENT"



// function prototypes
//
int flows_init( int argc, char *argv[], PentiumClock *keystroke_interval,
    PentiumClock *query_interval, PentiumClock *active_interval,
    int *want_facility_loopback, int *want_rx, int *want_tx );
int flows_per_block( BufferBlock *block );
int flows_per_packet( cellhashrec *packet, Bit8 interface );
int flows_is_query_wanted( void );
int flows_is_query_pending( void );
void flows_print_query_results( void );
int flows_query( const char *extra_msg );
int flows_cleanup( void );
void flows_send_active( void );    /* klt - 10/31/96 */
void flows_keystroke( int keystroke );
void dump_flow( void *sock, struct hashrec *hp );



#endif     // not included yet
