#ifndef _UTIL_H
#define _UTIL_H



#include "../integrat/trace.h"                      // struct tracerec
#include "../integrat/aal5.h"                       // struct cellhashrec
#include "../integrat/queue.h"                      // struct flowdata



/*
 * next part deals with user options and their
 * relationship with hashing and comparing
 */

extern void update_sh( cellhashrec *, flowdata *, Bit8 );
extern void update_sn( cellhashrec *, flowdata *, Bit8 );
extern void update_dh( cellhashrec *, flowdata *, Bit8 );
extern void update_dn( cellhashrec *, flowdata *, Bit8 );
extern void update_np( cellhashrec *, flowdata *, Bit8 );
extern void update_hp( cellhashrec *, flowdata *, Bit8 );
extern void update_pq( cellhashrec *, flowdata *, Bit8 );

struct objdesc {
    char *option;
    void (*update)(cellhashrec *, flowdata *, Bit8);
};

extern struct objdesc objtypes[];
#define NOBJ    (sizeof(objtypes) / sizeof(objtypes[0]))
#define PORTQUAD_OBJ_INDEX    0

#define TRUE    1
#define FALSE   0

int findobj( char *cp );
void dumpobjtypes();



#if BIT64_AVAILABLE
#define flowcmp(f1,f2) \
    ( \
        /* 32-bit hash key */ \
        (f1)->fd_index == (f2)->fd_index && \
\
        /* src IP and dest IP together */ \
        *(Bit64 *)(f1) == *(Bit64 *)(f2) && \
\
        /* MAC interface, IP protocol, TCP src port and TCP dest port together */ \
        *(Bit64 *)(8 + (Bit8 *)(f1)) >> 16 == *(Bit64 *)(8 + (Bit8 *)(f2)) >> 16 \
    )
#else
#define flowcmp(f1,f2) \
    ( \
        /* 32-bit hash key */ \
        (f1)->fd_index == (f2)->fd_index && \
\
        (f1)->fd_src.s_addr == (f2)->fd_src.s_addr && \
        (f1)->fd_dst.s_addr == (f2)->fd_dst.s_addr && \
\
        /* src and dest TCP ports together */ \
        *(Bit32 *)(12 + (Bit8 *)(f1)) == *(Bit32 *)(12 + (Bit8 *)(f2)) && \
\
        /* TCP flags and MAC interface together */ \
        *(Bit16 *)(10 + (Bit8 *)(f1)) == *(Bit16 *)(10 + (Bit8 *)(f2)) \
    )
#endif



#endif      // not included yet
