#  1700, Sat 3 May 97
#
#  Makefile for 16-bit (large memory model) SNMPv2C
#

DEBUG =     D    # E to enable, D to disable
PROCESSOR = 3    # 3 for 386..Pentium, 5 for Pentium only
CC =  bcc -ml    # Large memory model

SDEBUG = -DDEBUG  # We want the snmp error() messages  <--

!if '$(DEBUG)'=='E'
CDEBUG = -v
ADEBUG = -zi
TEXTDEBUG = enabled
!elif '$(DEBUG)'=='D'
TEXTDEBUG = disabled
!else
!error  DEBUG must be set to either E or D
!endif
!if '$(PROCESSOR)'=='3'
PROC = -3 -DCLK_86
!elif '$(PROCESSOR)'=='5'
PROC = -5
!else
!error  PROCESSOR must be set to either 3 or 5
!endif

CFLAGS = $(PROC) -w-par -a- -Otabeiv -O -Z  $(CDEBUG) \
    $(SDEBUG) -DDOS -I..\snmplib -I..\wattcp

SRC = ..\SNMPLIB
LIBNAME = snmpv2c

.c.obj:
    $(CC) $(CFLAGS) -c $*.c
    tlib $(LIBNAME) -+$@

SNMPINCLS = $(SRC)\ausnmp.h \
    $(SRC)\asn1.h $(SRC)\mib.h $(SRC)\snmp.h $(SRC)\snmpimpl.h

SNMPOBJS = asn1.obj snmp.obj snmpagnt.obj snmpauth.obj \
    mib.obj parse.obj snmpapi.obj snmpclnt.obj

all: $(SNMPOBJS)
        echo done

asn1.obj:     $(SRC)\asn1.c $(SNMPINCLS)
snmp.obj:     $(SRC)\snmp.c $(SNMPINCLS)
snmpagnt.obj: $(SRC)\snmpagnt.c $(SNMPINCLS)
snmpauth.obj: $(SRC)\snmpauth.c $(SNMPINCLS)
mib.obj:      $(SRC)\mib.c $(SNMPINCLS)
parse.obj:    $(SRC)\parse.c $(SNMPINCLS)
snmpapi.obj:  $(SRC)\snmpapi.c $(SNMPINCLS)
snmpclnt.obj: $(SRC)\snmpclnt.c $(SNMPINCLS)

clean:
    del err*.*
    del $(LIBNAME).lib
    del $(LIBNAME).bak
    del asn1.obj
    del snmp.obj
    del snmpagnt.obj
    del snmpauth.obj
    del mib.obj
    del parse.obj
    del snmpapi.obj
    del snmpclnt.obj
