#include "..\wattcp\copyrigh.h"
#include "..\wattcp\wattcp.h"

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

/* socket based stuff */


sock_printf( sock_type *s, char *format, ... )
{
    va_list argptr;
    int length;

    va_start( argptr, format );

    if( (s->udp.ip_type==IPPROTO_UDP && s->udp.safetysig==SAFETYUDP)
    ||  (s->tcp.ip_type==IPPROTO_TCP && s->tcp.safetysig==SAFETYTCP) )
    {
        char buffer[ tcp_MaxBufSize ];

        vsprintf( buffer, format, argptr );

        if ( (length = strlen( buffer )) > tcp_MaxBufSize )
        {
            outs("ERROR: tcp sock_Printf overrun\n\r");
            length = 0;
        }
        else
            sock_puts( s, buffer );
    }
    else
    {
        length = vfprintf( &s->file, format, argptr );
    }

    va_end( argptr );
    return( length );
}



/*
 * sock_scanf - return number of fields returned
 */
sock_scanf( sock_type *s, char *format, ... )
{
    va_list argptr;
    int fields;

    va_start( argptr, format );

    if( (s->udp.ip_type==IPPROTO_UDP && s->udp.safetysig==SAFETYUDP)
    ||  (s->tcp.ip_type==IPPROTO_TCP && s->tcp.safetysig==SAFETYTCP) )
    {
        char buffer[ tcp_MaxBufSize ];
        int status;

        fields = 0;
        while (!( status = sock_dataready( s ))) {
            if (status == -1)
            {
                fields = -1;
                break;
            }
            fields = sock_gets( s, buffer, tcp_MaxBufSize );
            if( fields )
                fields = vsscanf( buffer, format, argptr );
        }
    }
    else
    {
        fields = vfscanf( &s->file, format, argptr );
    }

    va_end( argptr );
    return( fields );
}
